package com.szpg.rmi;

import com.szpg.db.dao.PgDeviceDao;
import com.szpg.db.dao.PgSbDao;
import com.szpg.db.dao.impl.PgDeviceDaoImpl;
import com.szpg.db.dao.impl.PgSbDaoImpl;
import com.szpg.db.data.PgSbStat;
import org.apache.log4j.Logger;
import org.apache.struts2.ServletActionContext;

import com.opensymphony.xwork2.ActionSupport;
import com.szpg.db.dao.PgAcuDao;
import com.szpg.db.dao.impl.PgAcuDaoImpl;
import com.szpg.db.data.PgAcu;
import com.szpg.plc.message.AppMessageConstants;
import com.szpg.plc.message.command.ReadMemoryCommand;
import com.szpg.plc.protocol.fins.FINSConstants;
import com.szpg.plc.server.ACUClient;
import com.szpg.plc.server.ACUClientUtil;
import com.szpg.plc.util.ByteUtil;
import com.szpg.service.ReadControllerStatusService;
import com.szpg.util.Configure;
import com.szpg.util.UnicodeConvertor;

import z.json.JSONObject;

public class RemoteSBCommandAction extends ActionSupport {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2221187086461756012L;

	private String zcbh;
	
	private String format;
	private String jsoncallback;
	
	private Logger logger = Logger.getLogger(this.getClass().getName());
	
	public String getZcbh() {
		return zcbh;
	}

	public void setZcbh(String zcbh) {
		this.zcbh = zcbh;
	}

	public String getFormat() {
		return format;
	}

	public void setFormat(String format) {
		this.format = format;
	}

	public String getJsoncallback() {
		return jsoncallback;
	}

	public void setJsoncallback(String jsoncallback) {
		this.jsoncallback = jsoncallback;
	}
	
	/**
	 * 读取水泵实时状态
	 * @return
	 * @throws Exception
	 */
	public String readSbStatus() throws Exception {
		// 返回结果
		JSONObject jResult = new JSONObject();
		
		PgAcuDao acuDao = new PgAcuDaoImpl();
		
		if (null == zcbh || zcbh.equals("") == true) {
			jResult.put("success", false);
			jResult.put("code", "1");
			jResult.put("resaon", UnicodeConvertor.string2Unicode("资产编号为空"));
			
			returnToFront(jResult);
			return null;
		}
		
		String acucode = zcbh.substring(0, zcbh.indexOf(".", 6));
		PgAcu acu = acuDao.findACUByCode(acucode);
		if (null == acu) {
			jResult.put("success", false);
			jResult.put("code", "2");
			jResult.put("resaon", UnicodeConvertor.string2Unicode("未找到资产对应的PLC主机"));
			
			returnToFront(jResult);
			return null;
		}
		
		ACUClient client = ACUClientUtil.getInstance().getClients().get(acu.getAcu_host() + ":" + acu.getAcu_port());
		if (null != client) {
			ReadMemoryCommand command = ReadMemoryCommand.getInstance(AppMessageConstants.CMD_TYPE_READSBSTAT);
			String sour = Configure.getProperty("sys", "LOCALHOST.NET") + 
						  Configure.getProperty("sys", "LOCALHOST.NODE") + 
						  Configure.getProperty("sys", "LOCALHOST.UNIT");
			command.setMessageProducerId(sour);
			command.setMessageProducerHost(client.getHost());
			
			String dest = client.getNet() + client.getNode() + client.getUnit();
			command.setDestinationId(dest);
			command.setMemoryArea(FINSConstants.MEMORY_WORK_AREA_WORD); //按字读取内容
			// 二期水泵状态所在内存区域为D区
			if (client.getFlag().equals("23") || client.getFlag().equals("24")) {
				command.setMemoryArea(FINSConstants.MEMORY_DM_AREA);
			}
			
			try {
				// 没有找到对应的配置项，直接返回
				String start = Configure.getProperty("acubl", client.getAcucode() + ".SBSTAT.START");
				String countWord = Configure.getProperty("acubl", client.getAcucode() + ".SBSTAT.WORDCOUNT");
				if (null == start || start.equals("")) {
					jResult.put("success", false);
					jResult.put("code", "4");
					jResult.put("resaon", UnicodeConvertor.string2Unicode("未找到对应的变量配置项"));

					returnToFront(jResult);
					return null;
				}

				// 设置读取的地址范围
				// 从配置文件读取而来
				command.setStartAddress(ByteUtil.binToHexString(ByteUtil.intToBins(Integer.parseInt(start), 2)) + "00");
				command.setCountWord(Integer.parseInt(countWord));
				
				// 调用服务过程执行命令发送服务
				ReadControllerStatusService service = new ReadControllerStatusService();
				service.executeService(client, command);
				logger.info(command);
			} catch (Exception ex) {
				logger.error("发送查询水泵指令异常" + ex);
			}
			
			jResult.put("success", true);
			jResult.put("resaon", UnicodeConvertor.string2Unicode("发送成功，请等待响应"));
			
			returnToFront(jResult);
			return null;
		} else {
			jResult.put("success", false);
			jResult.put("code", "3");
			jResult.put("resaon", UnicodeConvertor.string2Unicode("PLC主机不在线"));
			
			returnToFront(jResult);
			return null;
		}
	}

	public String readSbStatusFromDB() throws Exception {
		// 返回结果
		JSONObject jResult = new JSONObject();

		PgDeviceDao deviceDao = new PgDeviceDaoImpl();
		PgSbDao sbDao = new PgSbDaoImpl();

		int deviceId = deviceDao.findDeviceIdByCode(zcbh);
		if (deviceId > 0) {
			PgSbStat sbStat = sbDao.findLatestStatByDevice(deviceId);
			if (null != sbStat) {
				jResult.put("sbStat", sbStat.toJson());
			}
		}

		returnToFront(jResult);
		return null;
	}
	
	
	/**
	 * 给前端返回
	 * @param jResult
	 * @throws Exception
	 */
	private void returnToFront(JSONObject jResult) throws Exception {
		// 返回jsonp格式的数据
		if (null != format && format.equalsIgnoreCase("jsonp") == true) {
			ServletActionContext.getResponse().getWriter().write(jsoncallback + "(" + jResult.toString() + ");");
		}

		ServletActionContext.getResponse().getWriter().write(jResult.toString());
	}
}
